// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: isoworldremote.proto
#ifdef _MSC_VER
#pragma warning(disable:4125)
#endif
#include "isoworldremote.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/port.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/io/zero_copy_stream_impl_lite.h>
// This is a temporary google only hack
#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
#include "third_party/protobuf/version.h"
#endif
// @@protoc_insertion_point(includes)

namespace protobuf_isoworldremote_2eproto {
extern PROTOBUF_INTERNAL_EXPORT_protobuf_isoworldremote_2eproto ::google::protobuf::internal::SCCInfo<0> scc_info_ColorDefinition;
extern PROTOBUF_INTERNAL_EXPORT_protobuf_isoworldremote_2eproto ::google::protobuf::internal::SCCInfo<1> scc_info_EmbarkTileLayer;
}  // namespace protobuf_isoworldremote_2eproto
namespace isoworldremote {
class ColorDefinitionDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<ColorDefinition>
      _instance;
} _ColorDefinition_default_instance_;
class EmbarkTileLayerDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<EmbarkTileLayer>
      _instance;
} _EmbarkTileLayer_default_instance_;
class EmbarkTileDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<EmbarkTile>
      _instance;
} _EmbarkTile_default_instance_;
class TileRequestDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<TileRequest>
      _instance;
} _TileRequest_default_instance_;
class MapRequestDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<MapRequest>
      _instance;
} _MapRequest_default_instance_;
class MapReplyDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<MapReply>
      _instance;
} _MapReply_default_instance_;
class RawNamesDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<RawNames>
      _instance;
} _RawNames_default_instance_;
}  // namespace isoworldremote
namespace protobuf_isoworldremote_2eproto {
static void InitDefaultsColorDefinition() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::isoworldremote::_ColorDefinition_default_instance_;
    new (ptr) ::isoworldremote::ColorDefinition();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::isoworldremote::ColorDefinition::InitAsDefaultInstance();
}

::google::protobuf::internal::SCCInfo<0> scc_info_ColorDefinition =
    {{ATOMIC_VAR_INIT(::google::protobuf::internal::SCCInfoBase::kUninitialized), 0, InitDefaultsColorDefinition}, {}};

static void InitDefaultsEmbarkTileLayer() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::isoworldremote::_EmbarkTileLayer_default_instance_;
    new (ptr) ::isoworldremote::EmbarkTileLayer();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::isoworldremote::EmbarkTileLayer::InitAsDefaultInstance();
}

::google::protobuf::internal::SCCInfo<1> scc_info_EmbarkTileLayer =
    {{ATOMIC_VAR_INIT(::google::protobuf::internal::SCCInfoBase::kUninitialized), 1, InitDefaultsEmbarkTileLayer}, {
      &protobuf_isoworldremote_2eproto::scc_info_ColorDefinition.base,}};

static void InitDefaultsEmbarkTile() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::isoworldremote::_EmbarkTile_default_instance_;
    new (ptr) ::isoworldremote::EmbarkTile();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::isoworldremote::EmbarkTile::InitAsDefaultInstance();
}

::google::protobuf::internal::SCCInfo<1> scc_info_EmbarkTile =
    {{ATOMIC_VAR_INIT(::google::protobuf::internal::SCCInfoBase::kUninitialized), 1, InitDefaultsEmbarkTile}, {
      &protobuf_isoworldremote_2eproto::scc_info_EmbarkTileLayer.base,}};

static void InitDefaultsTileRequest() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::isoworldremote::_TileRequest_default_instance_;
    new (ptr) ::isoworldremote::TileRequest();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::isoworldremote::TileRequest::InitAsDefaultInstance();
}

::google::protobuf::internal::SCCInfo<0> scc_info_TileRequest =
    {{ATOMIC_VAR_INIT(::google::protobuf::internal::SCCInfoBase::kUninitialized), 0, InitDefaultsTileRequest}, {}};

static void InitDefaultsMapRequest() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::isoworldremote::_MapRequest_default_instance_;
    new (ptr) ::isoworldremote::MapRequest();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::isoworldremote::MapRequest::InitAsDefaultInstance();
}

::google::protobuf::internal::SCCInfo<0> scc_info_MapRequest =
    {{ATOMIC_VAR_INIT(::google::protobuf::internal::SCCInfoBase::kUninitialized), 0, InitDefaultsMapRequest}, {}};

static void InitDefaultsMapReply() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::isoworldremote::_MapReply_default_instance_;
    new (ptr) ::isoworldremote::MapReply();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::isoworldremote::MapReply::InitAsDefaultInstance();
}

::google::protobuf::internal::SCCInfo<0> scc_info_MapReply =
    {{ATOMIC_VAR_INIT(::google::protobuf::internal::SCCInfoBase::kUninitialized), 0, InitDefaultsMapReply}, {}};

static void InitDefaultsRawNames() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::isoworldremote::_RawNames_default_instance_;
    new (ptr) ::isoworldremote::RawNames();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::isoworldremote::RawNames::InitAsDefaultInstance();
}

::google::protobuf::internal::SCCInfo<0> scc_info_RawNames =
    {{ATOMIC_VAR_INIT(::google::protobuf::internal::SCCInfoBase::kUninitialized), 0, InitDefaultsRawNames}, {}};

void InitDefaults() {
  ::google::protobuf::internal::InitSCC(&scc_info_ColorDefinition.base);
  ::google::protobuf::internal::InitSCC(&scc_info_EmbarkTileLayer.base);
  ::google::protobuf::internal::InitSCC(&scc_info_EmbarkTile.base);
  ::google::protobuf::internal::InitSCC(&scc_info_TileRequest.base);
  ::google::protobuf::internal::InitSCC(&scc_info_MapRequest.base);
  ::google::protobuf::internal::InitSCC(&scc_info_MapReply.base);
  ::google::protobuf::internal::InitSCC(&scc_info_RawNames.base);
}

}  // namespace protobuf_isoworldremote_2eproto
namespace isoworldremote {
bool BasicMaterial_IsValid(int value) {
  switch (value) {
    case 0:
    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
      return true;
    default:
      return false;
  }
}

bool LiquidType_IsValid(int value) {
  switch (value) {
    case 0:
    case 1:
    case 2:
      return true;
    default:
      return false;
  }
}

bool BasicShape_IsValid(int value) {
  switch (value) {
    case 0:
    case 1:
    case 3:
    case 4:
    case 5:
    case 6:
      return true;
    default:
      return false;
  }
}


// ===================================================================

void ColorDefinition::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int ColorDefinition::kRedFieldNumber;
const int ColorDefinition::kGreenFieldNumber;
const int ColorDefinition::kBlueFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

ColorDefinition::ColorDefinition()
  : ::google::protobuf::MessageLite(), _internal_metadata_(NULL) {
  ::google::protobuf::internal::InitSCC(
      &protobuf_isoworldremote_2eproto::scc_info_ColorDefinition.base);
  SharedCtor();
  // @@protoc_insertion_point(constructor:isoworldremote.ColorDefinition)
}
ColorDefinition::ColorDefinition(const ColorDefinition& from)
  : ::google::protobuf::MessageLite(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::memcpy(&red_, &from.red_,
    static_cast<size_t>(reinterpret_cast<char*>(&blue_) -
    reinterpret_cast<char*>(&red_)) + sizeof(blue_));
  // @@protoc_insertion_point(copy_constructor:isoworldremote.ColorDefinition)
}

void ColorDefinition::SharedCtor() {
  ::memset(&red_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&blue_) -
      reinterpret_cast<char*>(&red_)) + sizeof(blue_));
}

ColorDefinition::~ColorDefinition() {
  // @@protoc_insertion_point(destructor:isoworldremote.ColorDefinition)
  SharedDtor();
}

void ColorDefinition::SharedDtor() {
}

void ColorDefinition::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const ColorDefinition& ColorDefinition::default_instance() {
  ::google::protobuf::internal::InitSCC(&protobuf_isoworldremote_2eproto::scc_info_ColorDefinition.base);
  return *internal_default_instance();
}


void ColorDefinition::Clear() {
// @@protoc_insertion_point(message_clear_start:isoworldremote.ColorDefinition)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  if (cached_has_bits & 7u) {
    ::memset(&red_, 0, static_cast<size_t>(
        reinterpret_cast<char*>(&blue_) -
        reinterpret_cast<char*>(&red_)) + sizeof(blue_));
  }
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool ColorDefinition::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  ::google::protobuf::internal::LiteUnknownFieldSetter unknown_fields_setter(
      &_internal_metadata_);
  ::google::protobuf::io::StringOutputStream unknown_fields_output(
      unknown_fields_setter.buffer());
  ::google::protobuf::io::CodedOutputStream unknown_fields_stream(
      &unknown_fields_output, false);
  // @@protoc_insertion_point(parse_start:isoworldremote.ColorDefinition)
  for (;;) {
    ::std::pair<::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // required int32 red = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {
          set_has_red();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &red_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // required int32 green = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(16u /* 16 & 0xFF */)) {
          set_has_green();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &green_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // required int32 blue = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(24u /* 24 & 0xFF */)) {
          set_has_blue();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &blue_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormatLite::SkipField(
            input, tag, &unknown_fields_stream));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:isoworldremote.ColorDefinition)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:isoworldremote.ColorDefinition)
  return false;
#undef DO_
}

void ColorDefinition::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:isoworldremote.ColorDefinition)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // required int32 red = 1;
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(1, this->red(), output);
  }

  // required int32 green = 2;
  if (cached_has_bits & 0x00000002u) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(2, this->green(), output);
  }

  // required int32 blue = 3;
  if (cached_has_bits & 0x00000004u) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(3, this->blue(), output);
  }

  output->WriteRaw(_internal_metadata_.unknown_fields().data(),
                   static_cast<int>(_internal_metadata_.unknown_fields().size()));
  // @@protoc_insertion_point(serialize_end:isoworldremote.ColorDefinition)
}

size_t ColorDefinition::RequiredFieldsByteSizeFallback() const {
// @@protoc_insertion_point(required_fields_byte_size_fallback_start:isoworldremote.ColorDefinition)
  size_t total_size = 0;

  if (has_red()) {
    // required int32 red = 1;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::Int32Size(
        this->red());
  }

  if (has_green()) {
    // required int32 green = 2;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::Int32Size(
        this->green());
  }

  if (has_blue()) {
    // required int32 blue = 3;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::Int32Size(
        this->blue());
  }

  return total_size;
}
size_t ColorDefinition::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:isoworldremote.ColorDefinition)
  size_t total_size = 0;

  total_size += _internal_metadata_.unknown_fields().size();

  if (((_has_bits_[0] & 0x00000007) ^ 0x00000007) == 0) {  // All required fields are present.
    // required int32 red = 1;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::Int32Size(
        this->red());

    // required int32 green = 2;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::Int32Size(
        this->green());

    // required int32 blue = 3;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::Int32Size(
        this->blue());

  } else {
    total_size += RequiredFieldsByteSizeFallback();
  }
  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void ColorDefinition::CheckTypeAndMergeFrom(
    const ::google::protobuf::MessageLite& from) {
  MergeFrom(*::google::protobuf::down_cast<const ColorDefinition*>(&from));
}

void ColorDefinition::MergeFrom(const ColorDefinition& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:isoworldremote.ColorDefinition)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = from._has_bits_[0];
  if (cached_has_bits & 7u) {
    if (cached_has_bits & 0x00000001u) {
      red_ = from.red_;
    }
    if (cached_has_bits & 0x00000002u) {
      green_ = from.green_;
    }
    if (cached_has_bits & 0x00000004u) {
      blue_ = from.blue_;
    }
    _has_bits_[0] |= cached_has_bits;
  }
}

void ColorDefinition::CopyFrom(const ColorDefinition& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:isoworldremote.ColorDefinition)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool ColorDefinition::IsInitialized() const {
  if ((_has_bits_[0] & 0x00000007) != 0x00000007) return false;
  return true;
}

void ColorDefinition::Swap(ColorDefinition* other) {
  if (other == this) return;
  InternalSwap(other);
}
void ColorDefinition::InternalSwap(ColorDefinition* other) {
  using std::swap;
  swap(red_, other->red_);
  swap(green_, other->green_);
  swap(blue_, other->blue_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
}

::std::string ColorDefinition::GetTypeName() const {
  return "isoworldremote.ColorDefinition";
}


// ===================================================================

void EmbarkTileLayer::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int EmbarkTileLayer::kMatTypeTableFieldNumber;
const int EmbarkTileLayer::kMatSubtypeTableFieldNumber;
const int EmbarkTileLayer::kTileShapeTableFieldNumber;
const int EmbarkTileLayer::kTileColorTableFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

EmbarkTileLayer::EmbarkTileLayer()
  : ::google::protobuf::MessageLite(), _internal_metadata_(NULL) {
  ::google::protobuf::internal::InitSCC(
      &protobuf_isoworldremote_2eproto::scc_info_EmbarkTileLayer.base);
  SharedCtor();
  // @@protoc_insertion_point(constructor:isoworldremote.EmbarkTileLayer)
}
EmbarkTileLayer::EmbarkTileLayer(const EmbarkTileLayer& from)
  : ::google::protobuf::MessageLite(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_),
      mat_type_table_(from.mat_type_table_),
      mat_subtype_table_(from.mat_subtype_table_),
      tile_shape_table_(from.tile_shape_table_),
      tile_color_table_(from.tile_color_table_) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  // @@protoc_insertion_point(copy_constructor:isoworldremote.EmbarkTileLayer)
}

void EmbarkTileLayer::SharedCtor() {
}

EmbarkTileLayer::~EmbarkTileLayer() {
  // @@protoc_insertion_point(destructor:isoworldremote.EmbarkTileLayer)
  SharedDtor();
}

void EmbarkTileLayer::SharedDtor() {
}

void EmbarkTileLayer::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const EmbarkTileLayer& EmbarkTileLayer::default_instance() {
  ::google::protobuf::internal::InitSCC(&protobuf_isoworldremote_2eproto::scc_info_EmbarkTileLayer.base);
  return *internal_default_instance();
}


void EmbarkTileLayer::Clear() {
// @@protoc_insertion_point(message_clear_start:isoworldremote.EmbarkTileLayer)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  mat_type_table_.Clear();
  mat_subtype_table_.Clear();
  tile_shape_table_.Clear();
  tile_color_table_.Clear();
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool EmbarkTileLayer::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  ::google::protobuf::internal::LiteUnknownFieldSetter unknown_fields_setter(
      &_internal_metadata_);
  ::google::protobuf::io::StringOutputStream unknown_fields_output(
      unknown_fields_setter.buffer());
  ::google::protobuf::io::CodedOutputStream unknown_fields_stream(
      &unknown_fields_output, false);
  // @@protoc_insertion_point(parse_start:isoworldremote.EmbarkTileLayer)
  for (;;) {
    ::std::pair<::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated .isoworldremote.BasicMaterial mat_type_table = 4 [packed = true];
      case 4: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(34u /* 34 & 0xFF */)) {
          ::google::protobuf::uint32 length;
          DO_(input->ReadVarint32(&length));
          ::google::protobuf::io::CodedInputStream::Limit limit = input->PushLimit(static_cast<int>(length));
          while (input->BytesUntilLimit() > 0) {
            int value;
            DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
            if (::isoworldremote::BasicMaterial_IsValid(value)) {
              add_mat_type_table(static_cast< ::isoworldremote::BasicMaterial >(value));
            } else {
              unknown_fields_stream.WriteVarint32(tag);
              unknown_fields_stream.WriteVarint32(
                  static_cast< ::google::protobuf::uint32>(value));
            }
          }
          input->PopLimit(limit);
        } else if (
            static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(32u /* 32 & 0xFF */)) {
          int value;
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
          if (::isoworldremote::BasicMaterial_IsValid(value)) {
            add_mat_type_table(static_cast< ::isoworldremote::BasicMaterial >(value));
          } else {
            unknown_fields_stream.WriteVarint32(tag);
            unknown_fields_stream.WriteVarint32(
                static_cast< ::google::protobuf::uint32>(value));
          }
        } else {
          goto handle_unusual;
        }
        break;
      }

      // repeated int32 mat_subtype_table = 5 [packed = true];
      case 5: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(42u /* 42 & 0xFF */)) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadPackedPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, this->mutable_mat_subtype_table())));
        } else if (
            static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(40u /* 40 & 0xFF */)) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadRepeatedPrimitiveNoInline<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 1, 42u, input, this->mutable_mat_subtype_table())));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // repeated .isoworldremote.BasicShape tile_shape_table = 6 [packed = true];
      case 6: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(50u /* 50 & 0xFF */)) {
          ::google::protobuf::uint32 length;
          DO_(input->ReadVarint32(&length));
          ::google::protobuf::io::CodedInputStream::Limit limit = input->PushLimit(static_cast<int>(length));
          while (input->BytesUntilLimit() > 0) {
            int value;
            DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
            if (::isoworldremote::BasicShape_IsValid(value)) {
              add_tile_shape_table(static_cast< ::isoworldremote::BasicShape >(value));
            } else {
              unknown_fields_stream.WriteVarint32(tag);
              unknown_fields_stream.WriteVarint32(
                  static_cast< ::google::protobuf::uint32>(value));
            }
          }
          input->PopLimit(limit);
        } else if (
            static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(48u /* 48 & 0xFF */)) {
          int value;
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
          if (::isoworldremote::BasicShape_IsValid(value)) {
            add_tile_shape_table(static_cast< ::isoworldremote::BasicShape >(value));
          } else {
            unknown_fields_stream.WriteVarint32(tag);
            unknown_fields_stream.WriteVarint32(
                static_cast< ::google::protobuf::uint32>(value));
          }
        } else {
          goto handle_unusual;
        }
        break;
      }

      // repeated .isoworldremote.ColorDefinition tile_color_table = 7;
      case 7: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(58u /* 58 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
                input, add_tile_color_table()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormatLite::SkipField(
            input, tag, &unknown_fields_stream));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:isoworldremote.EmbarkTileLayer)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:isoworldremote.EmbarkTileLayer)
  return false;
#undef DO_
}

void EmbarkTileLayer::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:isoworldremote.EmbarkTileLayer)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated .isoworldremote.BasicMaterial mat_type_table = 4 [packed = true];
  if (this->mat_type_table_size() > 0) {
    ::google::protobuf::internal::WireFormatLite::WriteTag(
      4,
      ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED,
      output);
    output->WriteVarint32(
        static_cast< ::google::protobuf::uint32>(_mat_type_table_cached_byte_size_));
  }
  for (int i = 0, n = this->mat_type_table_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteEnumNoTag(
      this->mat_type_table(i), output);
  }

  // repeated int32 mat_subtype_table = 5 [packed = true];
  if (this->mat_subtype_table_size() > 0) {
    ::google::protobuf::internal::WireFormatLite::WriteTag(5, ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED, output);
    output->WriteVarint32(static_cast< ::google::protobuf::uint32>(
        _mat_subtype_table_cached_byte_size_));
  }
  for (int i = 0, n = this->mat_subtype_table_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32NoTag(
      this->mat_subtype_table(i), output);
  }

  // repeated .isoworldremote.BasicShape tile_shape_table = 6 [packed = true];
  if (this->tile_shape_table_size() > 0) {
    ::google::protobuf::internal::WireFormatLite::WriteTag(
      6,
      ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED,
      output);
    output->WriteVarint32(
        static_cast< ::google::protobuf::uint32>(_tile_shape_table_cached_byte_size_));
  }
  for (int i = 0, n = this->tile_shape_table_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteEnumNoTag(
      this->tile_shape_table(i), output);
  }

  // repeated .isoworldremote.ColorDefinition tile_color_table = 7;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->tile_color_table_size()); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessage(
      7,
      this->tile_color_table(static_cast<int>(i)),
      output);
  }

  output->WriteRaw(_internal_metadata_.unknown_fields().data(),
                   static_cast<int>(_internal_metadata_.unknown_fields().size()));
  // @@protoc_insertion_point(serialize_end:isoworldremote.EmbarkTileLayer)
}

size_t EmbarkTileLayer::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:isoworldremote.EmbarkTileLayer)
  size_t total_size = 0;

  total_size += _internal_metadata_.unknown_fields().size();

  // repeated .isoworldremote.BasicMaterial mat_type_table = 4 [packed = true];
  {
    size_t data_size = 0;
    unsigned int count = static_cast<unsigned int>(this->mat_type_table_size());for (unsigned int i = 0; i < count; i++) {
      data_size += ::google::protobuf::internal::WireFormatLite::EnumSize(
        this->mat_type_table(static_cast<int>(i)));
    }
    if (data_size > 0) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
            static_cast< ::google::protobuf::int32>(data_size));
    }
    int cached_size = ::google::protobuf::internal::ToCachedSize(data_size);
    GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
    _mat_type_table_cached_byte_size_ = cached_size;
    GOOGLE_SAFE_CONCURRENT_WRITES_END();
    total_size += data_size;
  }

  // repeated int32 mat_subtype_table = 5 [packed = true];
  {
    size_t data_size = ::google::protobuf::internal::WireFormatLite::
      Int32Size(this->mat_subtype_table_);
    if (data_size > 0) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
            static_cast< ::google::protobuf::int32>(data_size));
    }
    int cached_size = ::google::protobuf::internal::ToCachedSize(data_size);
    GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
    _mat_subtype_table_cached_byte_size_ = cached_size;
    GOOGLE_SAFE_CONCURRENT_WRITES_END();
    total_size += data_size;
  }

  // repeated .isoworldremote.BasicShape tile_shape_table = 6 [packed = true];
  {
    size_t data_size = 0;
    unsigned int count = static_cast<unsigned int>(this->tile_shape_table_size());for (unsigned int i = 0; i < count; i++) {
      data_size += ::google::protobuf::internal::WireFormatLite::EnumSize(
        this->tile_shape_table(static_cast<int>(i)));
    }
    if (data_size > 0) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
            static_cast< ::google::protobuf::int32>(data_size));
    }
    int cached_size = ::google::protobuf::internal::ToCachedSize(data_size);
    GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
    _tile_shape_table_cached_byte_size_ = cached_size;
    GOOGLE_SAFE_CONCURRENT_WRITES_END();
    total_size += data_size;
  }

  // repeated .isoworldremote.ColorDefinition tile_color_table = 7;
  {
    unsigned int count = static_cast<unsigned int>(this->tile_color_table_size());
    total_size += 1UL * count;
    for (unsigned int i = 0; i < count; i++) {
      total_size +=
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          this->tile_color_table(static_cast<int>(i)));
    }
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void EmbarkTileLayer::CheckTypeAndMergeFrom(
    const ::google::protobuf::MessageLite& from) {
  MergeFrom(*::google::protobuf::down_cast<const EmbarkTileLayer*>(&from));
}

void EmbarkTileLayer::MergeFrom(const EmbarkTileLayer& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:isoworldremote.EmbarkTileLayer)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  mat_type_table_.MergeFrom(from.mat_type_table_);
  mat_subtype_table_.MergeFrom(from.mat_subtype_table_);
  tile_shape_table_.MergeFrom(from.tile_shape_table_);
  tile_color_table_.MergeFrom(from.tile_color_table_);
}

void EmbarkTileLayer::CopyFrom(const EmbarkTileLayer& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:isoworldremote.EmbarkTileLayer)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool EmbarkTileLayer::IsInitialized() const {
  if (!::google::protobuf::internal::AllAreInitialized(this->tile_color_table())) return false;
  return true;
}

void EmbarkTileLayer::Swap(EmbarkTileLayer* other) {
  if (other == this) return;
  InternalSwap(other);
}
void EmbarkTileLayer::InternalSwap(EmbarkTileLayer* other) {
  using std::swap;
  mat_type_table_.InternalSwap(&other->mat_type_table_);
  mat_subtype_table_.InternalSwap(&other->mat_subtype_table_);
  tile_shape_table_.InternalSwap(&other->tile_shape_table_);
  CastToBase(&tile_color_table_)->InternalSwap(CastToBase(&other->tile_color_table_));
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
}

::std::string EmbarkTileLayer::GetTypeName() const {
  return "isoworldremote.EmbarkTileLayer";
}


// ===================================================================

void EmbarkTile::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int EmbarkTile::kWorldXFieldNumber;
const int EmbarkTile::kWorldYFieldNumber;
const int EmbarkTile::kWorldZFieldNumber;
const int EmbarkTile::kTileLayerFieldNumber;
const int EmbarkTile::kCurrentYearFieldNumber;
const int EmbarkTile::kCurrentSeasonFieldNumber;
const int EmbarkTile::kIsValidFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

EmbarkTile::EmbarkTile()
  : ::google::protobuf::MessageLite(), _internal_metadata_(NULL) {
  ::google::protobuf::internal::InitSCC(
      &protobuf_isoworldremote_2eproto::scc_info_EmbarkTile.base);
  SharedCtor();
  // @@protoc_insertion_point(constructor:isoworldremote.EmbarkTile)
}
EmbarkTile::EmbarkTile(const EmbarkTile& from)
  : ::google::protobuf::MessageLite(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_),
      tile_layer_(from.tile_layer_) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::memcpy(&world_x_, &from.world_x_,
    static_cast<size_t>(reinterpret_cast<char*>(&is_valid_) -
    reinterpret_cast<char*>(&world_x_)) + sizeof(is_valid_));
  // @@protoc_insertion_point(copy_constructor:isoworldremote.EmbarkTile)
}

void EmbarkTile::SharedCtor() {
  ::memset(&world_x_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&is_valid_) -
      reinterpret_cast<char*>(&world_x_)) + sizeof(is_valid_));
}

EmbarkTile::~EmbarkTile() {
  // @@protoc_insertion_point(destructor:isoworldremote.EmbarkTile)
  SharedDtor();
}

void EmbarkTile::SharedDtor() {
}

void EmbarkTile::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const EmbarkTile& EmbarkTile::default_instance() {
  ::google::protobuf::internal::InitSCC(&protobuf_isoworldremote_2eproto::scc_info_EmbarkTile.base);
  return *internal_default_instance();
}


void EmbarkTile::Clear() {
// @@protoc_insertion_point(message_clear_start:isoworldremote.EmbarkTile)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  tile_layer_.Clear();
  cached_has_bits = _has_bits_[0];
  if (cached_has_bits & 63u) {
    ::memset(&world_x_, 0, static_cast<size_t>(
        reinterpret_cast<char*>(&is_valid_) -
        reinterpret_cast<char*>(&world_x_)) + sizeof(is_valid_));
  }
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool EmbarkTile::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  ::google::protobuf::internal::LiteUnknownFieldSetter unknown_fields_setter(
      &_internal_metadata_);
  ::google::protobuf::io::StringOutputStream unknown_fields_output(
      unknown_fields_setter.buffer());
  ::google::protobuf::io::CodedOutputStream unknown_fields_stream(
      &unknown_fields_output, false);
  // @@protoc_insertion_point(parse_start:isoworldremote.EmbarkTile)
  for (;;) {
    ::std::pair<::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // required int32 world_x = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {
          set_has_world_x();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &world_x_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // required int32 world_y = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(16u /* 16 & 0xFF */)) {
          set_has_world_y();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &world_y_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // required sint32 world_z = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(24u /* 24 & 0xFF */)) {
          set_has_world_z();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_SINT32>(
                 input, &world_z_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // repeated .isoworldremote.EmbarkTileLayer tile_layer = 4;
      case 4: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(34u /* 34 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
                input, add_tile_layer()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional int32 current_year = 5;
      case 5: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(40u /* 40 & 0xFF */)) {
          set_has_current_year();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &current_year_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional int32 current_season = 6;
      case 6: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(48u /* 48 & 0xFF */)) {
          set_has_current_season();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &current_season_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional bool is_valid = 7;
      case 7: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(56u /* 56 & 0xFF */)) {
          set_has_is_valid();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, &is_valid_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormatLite::SkipField(
            input, tag, &unknown_fields_stream));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:isoworldremote.EmbarkTile)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:isoworldremote.EmbarkTile)
  return false;
#undef DO_
}

void EmbarkTile::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:isoworldremote.EmbarkTile)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // required int32 world_x = 1;
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(1, this->world_x(), output);
  }

  // required int32 world_y = 2;
  if (cached_has_bits & 0x00000002u) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(2, this->world_y(), output);
  }

  // required sint32 world_z = 3;
  if (cached_has_bits & 0x00000004u) {
    ::google::protobuf::internal::WireFormatLite::WriteSInt32(3, this->world_z(), output);
  }

  // repeated .isoworldremote.EmbarkTileLayer tile_layer = 4;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->tile_layer_size()); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessage(
      4,
      this->tile_layer(static_cast<int>(i)),
      output);
  }

  // optional int32 current_year = 5;
  if (cached_has_bits & 0x00000008u) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(5, this->current_year(), output);
  }

  // optional int32 current_season = 6;
  if (cached_has_bits & 0x00000010u) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(6, this->current_season(), output);
  }

  // optional bool is_valid = 7;
  if (cached_has_bits & 0x00000020u) {
    ::google::protobuf::internal::WireFormatLite::WriteBool(7, this->is_valid(), output);
  }

  output->WriteRaw(_internal_metadata_.unknown_fields().data(),
                   static_cast<int>(_internal_metadata_.unknown_fields().size()));
  // @@protoc_insertion_point(serialize_end:isoworldremote.EmbarkTile)
}

size_t EmbarkTile::RequiredFieldsByteSizeFallback() const {
// @@protoc_insertion_point(required_fields_byte_size_fallback_start:isoworldremote.EmbarkTile)
  size_t total_size = 0;

  if (has_world_x()) {
    // required int32 world_x = 1;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::Int32Size(
        this->world_x());
  }

  if (has_world_y()) {
    // required int32 world_y = 2;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::Int32Size(
        this->world_y());
  }

  if (has_world_z()) {
    // required sint32 world_z = 3;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::SInt32Size(
        this->world_z());
  }

  return total_size;
}
size_t EmbarkTile::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:isoworldremote.EmbarkTile)
  size_t total_size = 0;

  total_size += _internal_metadata_.unknown_fields().size();

  if (((_has_bits_[0] & 0x00000007) ^ 0x00000007) == 0) {  // All required fields are present.
    // required int32 world_x = 1;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::Int32Size(
        this->world_x());

    // required int32 world_y = 2;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::Int32Size(
        this->world_y());

    // required sint32 world_z = 3;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::SInt32Size(
        this->world_z());

  } else {
    total_size += RequiredFieldsByteSizeFallback();
  }
  // repeated .isoworldremote.EmbarkTileLayer tile_layer = 4;
  {
    unsigned int count = static_cast<unsigned int>(this->tile_layer_size());
    total_size += 1UL * count;
    for (unsigned int i = 0; i < count; i++) {
      total_size +=
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          this->tile_layer(static_cast<int>(i)));
    }
  }

  if (_has_bits_[0 / 32] & 56u) {
    // optional int32 current_year = 5;
    if (has_current_year()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
          this->current_year());
    }

    // optional int32 current_season = 6;
    if (has_current_season()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
          this->current_season());
    }

    // optional bool is_valid = 7;
    if (has_is_valid()) {
      total_size += 1 + 1;
    }

  }
  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void EmbarkTile::CheckTypeAndMergeFrom(
    const ::google::protobuf::MessageLite& from) {
  MergeFrom(*::google::protobuf::down_cast<const EmbarkTile*>(&from));
}

void EmbarkTile::MergeFrom(const EmbarkTile& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:isoworldremote.EmbarkTile)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  tile_layer_.MergeFrom(from.tile_layer_);
  cached_has_bits = from._has_bits_[0];
  if (cached_has_bits & 63u) {
    if (cached_has_bits & 0x00000001u) {
      world_x_ = from.world_x_;
    }
    if (cached_has_bits & 0x00000002u) {
      world_y_ = from.world_y_;
    }
    if (cached_has_bits & 0x00000004u) {
      world_z_ = from.world_z_;
    }
    if (cached_has_bits & 0x00000008u) {
      current_year_ = from.current_year_;
    }
    if (cached_has_bits & 0x00000010u) {
      current_season_ = from.current_season_;
    }
    if (cached_has_bits & 0x00000020u) {
      is_valid_ = from.is_valid_;
    }
    _has_bits_[0] |= cached_has_bits;
  }
}

void EmbarkTile::CopyFrom(const EmbarkTile& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:isoworldremote.EmbarkTile)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool EmbarkTile::IsInitialized() const {
  if ((_has_bits_[0] & 0x00000007) != 0x00000007) return false;
  if (!::google::protobuf::internal::AllAreInitialized(this->tile_layer())) return false;
  return true;
}

void EmbarkTile::Swap(EmbarkTile* other) {
  if (other == this) return;
  InternalSwap(other);
}
void EmbarkTile::InternalSwap(EmbarkTile* other) {
  using std::swap;
  CastToBase(&tile_layer_)->InternalSwap(CastToBase(&other->tile_layer_));
  swap(world_x_, other->world_x_);
  swap(world_y_, other->world_y_);
  swap(world_z_, other->world_z_);
  swap(current_year_, other->current_year_);
  swap(current_season_, other->current_season_);
  swap(is_valid_, other->is_valid_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
}

::std::string EmbarkTile::GetTypeName() const {
  return "isoworldremote.EmbarkTile";
}


// ===================================================================

void TileRequest::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int TileRequest::kWantXFieldNumber;
const int TileRequest::kWantYFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

TileRequest::TileRequest()
  : ::google::protobuf::MessageLite(), _internal_metadata_(NULL) {
  ::google::protobuf::internal::InitSCC(
      &protobuf_isoworldremote_2eproto::scc_info_TileRequest.base);
  SharedCtor();
  // @@protoc_insertion_point(constructor:isoworldremote.TileRequest)
}
TileRequest::TileRequest(const TileRequest& from)
  : ::google::protobuf::MessageLite(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::memcpy(&want_x_, &from.want_x_,
    static_cast<size_t>(reinterpret_cast<char*>(&want_y_) -
    reinterpret_cast<char*>(&want_x_)) + sizeof(want_y_));
  // @@protoc_insertion_point(copy_constructor:isoworldremote.TileRequest)
}

void TileRequest::SharedCtor() {
  ::memset(&want_x_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&want_y_) -
      reinterpret_cast<char*>(&want_x_)) + sizeof(want_y_));
}

TileRequest::~TileRequest() {
  // @@protoc_insertion_point(destructor:isoworldremote.TileRequest)
  SharedDtor();
}

void TileRequest::SharedDtor() {
}

void TileRequest::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const TileRequest& TileRequest::default_instance() {
  ::google::protobuf::internal::InitSCC(&protobuf_isoworldremote_2eproto::scc_info_TileRequest.base);
  return *internal_default_instance();
}


void TileRequest::Clear() {
// @@protoc_insertion_point(message_clear_start:isoworldremote.TileRequest)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  if (cached_has_bits & 3u) {
    ::memset(&want_x_, 0, static_cast<size_t>(
        reinterpret_cast<char*>(&want_y_) -
        reinterpret_cast<char*>(&want_x_)) + sizeof(want_y_));
  }
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool TileRequest::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  ::google::protobuf::internal::LiteUnknownFieldSetter unknown_fields_setter(
      &_internal_metadata_);
  ::google::protobuf::io::StringOutputStream unknown_fields_output(
      unknown_fields_setter.buffer());
  ::google::protobuf::io::CodedOutputStream unknown_fields_stream(
      &unknown_fields_output, false);
  // @@protoc_insertion_point(parse_start:isoworldremote.TileRequest)
  for (;;) {
    ::std::pair<::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // optional int32 want_x = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {
          set_has_want_x();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &want_x_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional int32 want_y = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(16u /* 16 & 0xFF */)) {
          set_has_want_y();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &want_y_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormatLite::SkipField(
            input, tag, &unknown_fields_stream));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:isoworldremote.TileRequest)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:isoworldremote.TileRequest)
  return false;
#undef DO_
}

void TileRequest::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:isoworldremote.TileRequest)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // optional int32 want_x = 1;
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(1, this->want_x(), output);
  }

  // optional int32 want_y = 2;
  if (cached_has_bits & 0x00000002u) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(2, this->want_y(), output);
  }

  output->WriteRaw(_internal_metadata_.unknown_fields().data(),
                   static_cast<int>(_internal_metadata_.unknown_fields().size()));
  // @@protoc_insertion_point(serialize_end:isoworldremote.TileRequest)
}

size_t TileRequest::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:isoworldremote.TileRequest)
  size_t total_size = 0;

  total_size += _internal_metadata_.unknown_fields().size();

  if (_has_bits_[0 / 32] & 3u) {
    // optional int32 want_x = 1;
    if (has_want_x()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
          this->want_x());
    }

    // optional int32 want_y = 2;
    if (has_want_y()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
          this->want_y());
    }

  }
  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void TileRequest::CheckTypeAndMergeFrom(
    const ::google::protobuf::MessageLite& from) {
  MergeFrom(*::google::protobuf::down_cast<const TileRequest*>(&from));
}

void TileRequest::MergeFrom(const TileRequest& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:isoworldremote.TileRequest)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = from._has_bits_[0];
  if (cached_has_bits & 3u) {
    if (cached_has_bits & 0x00000001u) {
      want_x_ = from.want_x_;
    }
    if (cached_has_bits & 0x00000002u) {
      want_y_ = from.want_y_;
    }
    _has_bits_[0] |= cached_has_bits;
  }
}

void TileRequest::CopyFrom(const TileRequest& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:isoworldremote.TileRequest)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool TileRequest::IsInitialized() const {
  return true;
}

void TileRequest::Swap(TileRequest* other) {
  if (other == this) return;
  InternalSwap(other);
}
void TileRequest::InternalSwap(TileRequest* other) {
  using std::swap;
  swap(want_x_, other->want_x_);
  swap(want_y_, other->want_y_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
}

::std::string TileRequest::GetTypeName() const {
  return "isoworldremote.TileRequest";
}


// ===================================================================

void MapRequest::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int MapRequest::kSaveFolderFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

MapRequest::MapRequest()
  : ::google::protobuf::MessageLite(), _internal_metadata_(NULL) {
  ::google::protobuf::internal::InitSCC(
      &protobuf_isoworldremote_2eproto::scc_info_MapRequest.base);
  SharedCtor();
  // @@protoc_insertion_point(constructor:isoworldremote.MapRequest)
}
MapRequest::MapRequest(const MapRequest& from)
  : ::google::protobuf::MessageLite(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  save_folder_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.has_save_folder()) {
    save_folder_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.save_folder_);
  }
  // @@protoc_insertion_point(copy_constructor:isoworldremote.MapRequest)
}

void MapRequest::SharedCtor() {
  save_folder_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

MapRequest::~MapRequest() {
  // @@protoc_insertion_point(destructor:isoworldremote.MapRequest)
  SharedDtor();
}

void MapRequest::SharedDtor() {
  save_folder_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void MapRequest::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const MapRequest& MapRequest::default_instance() {
  ::google::protobuf::internal::InitSCC(&protobuf_isoworldremote_2eproto::scc_info_MapRequest.base);
  return *internal_default_instance();
}


void MapRequest::Clear() {
// @@protoc_insertion_point(message_clear_start:isoworldremote.MapRequest)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  if (cached_has_bits & 0x00000001u) {
    save_folder_.ClearNonDefaultToEmptyNoArena();
  }
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool MapRequest::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  ::google::protobuf::internal::LiteUnknownFieldSetter unknown_fields_setter(
      &_internal_metadata_);
  ::google::protobuf::io::StringOutputStream unknown_fields_output(
      unknown_fields_setter.buffer());
  ::google::protobuf::io::CodedOutputStream unknown_fields_stream(
      &unknown_fields_output, false);
  // @@protoc_insertion_point(parse_start:isoworldremote.MapRequest)
  for (;;) {
    ::std::pair<::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // optional string save_folder = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_save_folder()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormatLite::SkipField(
            input, tag, &unknown_fields_stream));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:isoworldremote.MapRequest)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:isoworldremote.MapRequest)
  return false;
#undef DO_
}

void MapRequest::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:isoworldremote.MapRequest)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // optional string save_folder = 1;
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->save_folder(), output);
  }

  output->WriteRaw(_internal_metadata_.unknown_fields().data(),
                   static_cast<int>(_internal_metadata_.unknown_fields().size()));
  // @@protoc_insertion_point(serialize_end:isoworldremote.MapRequest)
}

size_t MapRequest::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:isoworldremote.MapRequest)
  size_t total_size = 0;

  total_size += _internal_metadata_.unknown_fields().size();

  // optional string save_folder = 1;
  if (has_save_folder()) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->save_folder());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void MapRequest::CheckTypeAndMergeFrom(
    const ::google::protobuf::MessageLite& from) {
  MergeFrom(*::google::protobuf::down_cast<const MapRequest*>(&from));
}

void MapRequest::MergeFrom(const MapRequest& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:isoworldremote.MapRequest)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.has_save_folder()) {
    set_has_save_folder();
    save_folder_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.save_folder_);
  }
}

void MapRequest::CopyFrom(const MapRequest& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:isoworldremote.MapRequest)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool MapRequest::IsInitialized() const {
  return true;
}

void MapRequest::Swap(MapRequest* other) {
  if (other == this) return;
  InternalSwap(other);
}
void MapRequest::InternalSwap(MapRequest* other) {
  using std::swap;
  save_folder_.Swap(&other->save_folder_, &::google::protobuf::internal::GetEmptyStringAlreadyInited(),
    GetArenaNoVirtual());
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
}

::std::string MapRequest::GetTypeName() const {
  return "isoworldremote.MapRequest";
}


// ===================================================================

void MapReply::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int MapReply::kAvailableFieldNumber;
const int MapReply::kRegionXFieldNumber;
const int MapReply::kRegionYFieldNumber;
const int MapReply::kRegionSizeXFieldNumber;
const int MapReply::kRegionSizeYFieldNumber;
const int MapReply::kCurrentYearFieldNumber;
const int MapReply::kCurrentSeasonFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

MapReply::MapReply()
  : ::google::protobuf::MessageLite(), _internal_metadata_(NULL) {
  ::google::protobuf::internal::InitSCC(
      &protobuf_isoworldremote_2eproto::scc_info_MapReply.base);
  SharedCtor();
  // @@protoc_insertion_point(constructor:isoworldremote.MapReply)
}
MapReply::MapReply(const MapReply& from)
  : ::google::protobuf::MessageLite(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::memcpy(&available_, &from.available_,
    static_cast<size_t>(reinterpret_cast<char*>(&current_season_) -
    reinterpret_cast<char*>(&available_)) + sizeof(current_season_));
  // @@protoc_insertion_point(copy_constructor:isoworldremote.MapReply)
}

void MapReply::SharedCtor() {
  ::memset(&available_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&current_season_) -
      reinterpret_cast<char*>(&available_)) + sizeof(current_season_));
}

MapReply::~MapReply() {
  // @@protoc_insertion_point(destructor:isoworldremote.MapReply)
  SharedDtor();
}

void MapReply::SharedDtor() {
}

void MapReply::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const MapReply& MapReply::default_instance() {
  ::google::protobuf::internal::InitSCC(&protobuf_isoworldremote_2eproto::scc_info_MapReply.base);
  return *internal_default_instance();
}


void MapReply::Clear() {
// @@protoc_insertion_point(message_clear_start:isoworldremote.MapReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  if (cached_has_bits & 127u) {
    ::memset(&available_, 0, static_cast<size_t>(
        reinterpret_cast<char*>(&current_season_) -
        reinterpret_cast<char*>(&available_)) + sizeof(current_season_));
  }
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool MapReply::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  ::google::protobuf::internal::LiteUnknownFieldSetter unknown_fields_setter(
      &_internal_metadata_);
  ::google::protobuf::io::StringOutputStream unknown_fields_output(
      unknown_fields_setter.buffer());
  ::google::protobuf::io::CodedOutputStream unknown_fields_stream(
      &unknown_fields_output, false);
  // @@protoc_insertion_point(parse_start:isoworldremote.MapReply)
  for (;;) {
    ::std::pair<::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // required bool available = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {
          set_has_available();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, &available_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional int32 region_x = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(16u /* 16 & 0xFF */)) {
          set_has_region_x();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &region_x_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional int32 region_y = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(24u /* 24 & 0xFF */)) {
          set_has_region_y();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &region_y_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional int32 region_size_x = 4;
      case 4: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(32u /* 32 & 0xFF */)) {
          set_has_region_size_x();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &region_size_x_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional int32 region_size_y = 5;
      case 5: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(40u /* 40 & 0xFF */)) {
          set_has_region_size_y();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &region_size_y_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional int32 current_year = 6;
      case 6: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(48u /* 48 & 0xFF */)) {
          set_has_current_year();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &current_year_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional int32 current_season = 7;
      case 7: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(56u /* 56 & 0xFF */)) {
          set_has_current_season();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &current_season_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormatLite::SkipField(
            input, tag, &unknown_fields_stream));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:isoworldremote.MapReply)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:isoworldremote.MapReply)
  return false;
#undef DO_
}

void MapReply::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:isoworldremote.MapReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // required bool available = 1;
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormatLite::WriteBool(1, this->available(), output);
  }

  // optional int32 region_x = 2;
  if (cached_has_bits & 0x00000002u) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(2, this->region_x(), output);
  }

  // optional int32 region_y = 3;
  if (cached_has_bits & 0x00000004u) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(3, this->region_y(), output);
  }

  // optional int32 region_size_x = 4;
  if (cached_has_bits & 0x00000008u) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(4, this->region_size_x(), output);
  }

  // optional int32 region_size_y = 5;
  if (cached_has_bits & 0x00000010u) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(5, this->region_size_y(), output);
  }

  // optional int32 current_year = 6;
  if (cached_has_bits & 0x00000020u) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(6, this->current_year(), output);
  }

  // optional int32 current_season = 7;
  if (cached_has_bits & 0x00000040u) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(7, this->current_season(), output);
  }

  output->WriteRaw(_internal_metadata_.unknown_fields().data(),
                   static_cast<int>(_internal_metadata_.unknown_fields().size()));
  // @@protoc_insertion_point(serialize_end:isoworldremote.MapReply)
}

size_t MapReply::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:isoworldremote.MapReply)
  size_t total_size = 0;

  total_size += _internal_metadata_.unknown_fields().size();

  // required bool available = 1;
  if (has_available()) {
    total_size += 1 + 1;
  }
  if (_has_bits_[0 / 32] & 126u) {
    // optional int32 region_x = 2;
    if (has_region_x()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
          this->region_x());
    }

    // optional int32 region_y = 3;
    if (has_region_y()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
          this->region_y());
    }

    // optional int32 region_size_x = 4;
    if (has_region_size_x()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
          this->region_size_x());
    }

    // optional int32 region_size_y = 5;
    if (has_region_size_y()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
          this->region_size_y());
    }

    // optional int32 current_year = 6;
    if (has_current_year()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
          this->current_year());
    }

    // optional int32 current_season = 7;
    if (has_current_season()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
          this->current_season());
    }

  }
  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void MapReply::CheckTypeAndMergeFrom(
    const ::google::protobuf::MessageLite& from) {
  MergeFrom(*::google::protobuf::down_cast<const MapReply*>(&from));
}

void MapReply::MergeFrom(const MapReply& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:isoworldremote.MapReply)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = from._has_bits_[0];
  if (cached_has_bits & 127u) {
    if (cached_has_bits & 0x00000001u) {
      available_ = from.available_;
    }
    if (cached_has_bits & 0x00000002u) {
      region_x_ = from.region_x_;
    }
    if (cached_has_bits & 0x00000004u) {
      region_y_ = from.region_y_;
    }
    if (cached_has_bits & 0x00000008u) {
      region_size_x_ = from.region_size_x_;
    }
    if (cached_has_bits & 0x00000010u) {
      region_size_y_ = from.region_size_y_;
    }
    if (cached_has_bits & 0x00000020u) {
      current_year_ = from.current_year_;
    }
    if (cached_has_bits & 0x00000040u) {
      current_season_ = from.current_season_;
    }
    _has_bits_[0] |= cached_has_bits;
  }
}

void MapReply::CopyFrom(const MapReply& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:isoworldremote.MapReply)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool MapReply::IsInitialized() const {
  if ((_has_bits_[0] & 0x00000001) != 0x00000001) return false;
  return true;
}

void MapReply::Swap(MapReply* other) {
  if (other == this) return;
  InternalSwap(other);
}
void MapReply::InternalSwap(MapReply* other) {
  using std::swap;
  swap(available_, other->available_);
  swap(region_x_, other->region_x_);
  swap(region_y_, other->region_y_);
  swap(region_size_x_, other->region_size_x_);
  swap(region_size_y_, other->region_size_y_);
  swap(current_year_, other->current_year_);
  swap(current_season_, other->current_season_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
}

::std::string MapReply::GetTypeName() const {
  return "isoworldremote.MapReply";
}


// ===================================================================

void RawNames::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int RawNames::kAvailableFieldNumber;
const int RawNames::kInorganicFieldNumber;
const int RawNames::kOrganicFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

RawNames::RawNames()
  : ::google::protobuf::MessageLite(), _internal_metadata_(NULL) {
  ::google::protobuf::internal::InitSCC(
      &protobuf_isoworldremote_2eproto::scc_info_RawNames.base);
  SharedCtor();
  // @@protoc_insertion_point(constructor:isoworldremote.RawNames)
}
RawNames::RawNames(const RawNames& from)
  : ::google::protobuf::MessageLite(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_),
      inorganic_(from.inorganic_),
      organic_(from.organic_) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  available_ = from.available_;
  // @@protoc_insertion_point(copy_constructor:isoworldremote.RawNames)
}

void RawNames::SharedCtor() {
  available_ = false;
}

RawNames::~RawNames() {
  // @@protoc_insertion_point(destructor:isoworldremote.RawNames)
  SharedDtor();
}

void RawNames::SharedDtor() {
}

void RawNames::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const RawNames& RawNames::default_instance() {
  ::google::protobuf::internal::InitSCC(&protobuf_isoworldremote_2eproto::scc_info_RawNames.base);
  return *internal_default_instance();
}


void RawNames::Clear() {
// @@protoc_insertion_point(message_clear_start:isoworldremote.RawNames)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  inorganic_.Clear();
  organic_.Clear();
  available_ = false;
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool RawNames::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  ::google::protobuf::internal::LiteUnknownFieldSetter unknown_fields_setter(
      &_internal_metadata_);
  ::google::protobuf::io::StringOutputStream unknown_fields_output(
      unknown_fields_setter.buffer());
  ::google::protobuf::io::CodedOutputStream unknown_fields_stream(
      &unknown_fields_output, false);
  // @@protoc_insertion_point(parse_start:isoworldremote.RawNames)
  for (;;) {
    ::std::pair<::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // required bool available = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {
          set_has_available();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, &available_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // repeated string inorganic = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->add_inorganic()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // repeated string organic = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(26u /* 26 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->add_organic()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormatLite::SkipField(
            input, tag, &unknown_fields_stream));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:isoworldremote.RawNames)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:isoworldremote.RawNames)
  return false;
#undef DO_
}

void RawNames::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:isoworldremote.RawNames)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // required bool available = 1;
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormatLite::WriteBool(1, this->available(), output);
  }

  // repeated string inorganic = 2;
  for (int i = 0, n = this->inorganic_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteString(
      2, this->inorganic(i), output);
  }

  // repeated string organic = 3;
  for (int i = 0, n = this->organic_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteString(
      3, this->organic(i), output);
  }

  output->WriteRaw(_internal_metadata_.unknown_fields().data(),
                   static_cast<int>(_internal_metadata_.unknown_fields().size()));
  // @@protoc_insertion_point(serialize_end:isoworldremote.RawNames)
}

size_t RawNames::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:isoworldremote.RawNames)
  size_t total_size = 0;

  total_size += _internal_metadata_.unknown_fields().size();

  // required bool available = 1;
  if (has_available()) {
    total_size += 1 + 1;
  }
  // repeated string inorganic = 2;
  total_size += 1 *
      ::google::protobuf::internal::FromIntSize(this->inorganic_size());
  for (int i = 0, n = this->inorganic_size(); i < n; i++) {
    total_size += ::google::protobuf::internal::WireFormatLite::StringSize(
      this->inorganic(i));
  }

  // repeated string organic = 3;
  total_size += 1 *
      ::google::protobuf::internal::FromIntSize(this->organic_size());
  for (int i = 0, n = this->organic_size(); i < n; i++) {
    total_size += ::google::protobuf::internal::WireFormatLite::StringSize(
      this->organic(i));
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void RawNames::CheckTypeAndMergeFrom(
    const ::google::protobuf::MessageLite& from) {
  MergeFrom(*::google::protobuf::down_cast<const RawNames*>(&from));
}

void RawNames::MergeFrom(const RawNames& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:isoworldremote.RawNames)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  inorganic_.MergeFrom(from.inorganic_);
  organic_.MergeFrom(from.organic_);
  if (from.has_available()) {
    set_available(from.available());
  }
}

void RawNames::CopyFrom(const RawNames& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:isoworldremote.RawNames)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool RawNames::IsInitialized() const {
  if ((_has_bits_[0] & 0x00000001) != 0x00000001) return false;
  return true;
}

void RawNames::Swap(RawNames* other) {
  if (other == this) return;
  InternalSwap(other);
}
void RawNames::InternalSwap(RawNames* other) {
  using std::swap;
  inorganic_.InternalSwap(CastToBase(&other->inorganic_));
  organic_.InternalSwap(CastToBase(&other->organic_));
  swap(available_, other->available_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
}

::std::string RawNames::GetTypeName() const {
  return "isoworldremote.RawNames";
}


// @@protoc_insertion_point(namespace_scope)
}  // namespace isoworldremote
namespace google {
namespace protobuf {
template<> GOOGLE_PROTOBUF_ATTRIBUTE_NOINLINE ::isoworldremote::ColorDefinition* Arena::CreateMaybeMessage< ::isoworldremote::ColorDefinition >(Arena* arena) {
  return Arena::CreateInternal< ::isoworldremote::ColorDefinition >(arena);
}
template<> GOOGLE_PROTOBUF_ATTRIBUTE_NOINLINE ::isoworldremote::EmbarkTileLayer* Arena::CreateMaybeMessage< ::isoworldremote::EmbarkTileLayer >(Arena* arena) {
  return Arena::CreateInternal< ::isoworldremote::EmbarkTileLayer >(arena);
}
template<> GOOGLE_PROTOBUF_ATTRIBUTE_NOINLINE ::isoworldremote::EmbarkTile* Arena::CreateMaybeMessage< ::isoworldremote::EmbarkTile >(Arena* arena) {
  return Arena::CreateInternal< ::isoworldremote::EmbarkTile >(arena);
}
template<> GOOGLE_PROTOBUF_ATTRIBUTE_NOINLINE ::isoworldremote::TileRequest* Arena::CreateMaybeMessage< ::isoworldremote::TileRequest >(Arena* arena) {
  return Arena::CreateInternal< ::isoworldremote::TileRequest >(arena);
}
template<> GOOGLE_PROTOBUF_ATTRIBUTE_NOINLINE ::isoworldremote::MapRequest* Arena::CreateMaybeMessage< ::isoworldremote::MapRequest >(Arena* arena) {
  return Arena::CreateInternal< ::isoworldremote::MapRequest >(arena);
}
template<> GOOGLE_PROTOBUF_ATTRIBUTE_NOINLINE ::isoworldremote::MapReply* Arena::CreateMaybeMessage< ::isoworldremote::MapReply >(Arena* arena) {
  return Arena::CreateInternal< ::isoworldremote::MapReply >(arena);
}
template<> GOOGLE_PROTOBUF_ATTRIBUTE_NOINLINE ::isoworldremote::RawNames* Arena::CreateMaybeMessage< ::isoworldremote::RawNames >(Arena* arena) {
  return Arena::CreateInternal< ::isoworldremote::RawNames >(arena);
}
}  // namespace protobuf
}  // namespace google

// @@protoc_insertion_point(global_scope)
